<script>
    export let plot_element;
    export let data;
    export let xScale;
    export let yScale;
    import * as d3 from "d3";
    import {
        notification_modal_visible,
        notification_modal_content,
    } from "../../svelte_stores/notification_modal.js";

    // Default settings
    $: ymaxrow = yScale.domain()[1] - 0.5;
    // console.log(data.datalist);
    let colors = {};
    let row = {};
    if (plot_element.data.dataset == "xray_alerts_noaa") {
        colors = {
            ALTXMF: "red",
            SUMXM5: "blue",
            SUMX01: "blue",
            SUMX10: "blue",
            SUMX20: "blue",
        };
        row = {
            ALTXMF: 0,
            SUMXM5: 1,
            SUMX01: 2,
            SUMX10: 3,
            SUMX20: 4,
        };
    } else if (plot_element.data.dataset == "proton_alerts_noaa") {
        colors = {
            WARPX1: "orange",
            WARPX2: "orange",
            WARPX3: "orange",
            WARPX4: "orange",
            WARPX5: "orange",
            WARPC0: "orange",
            ALTX1: "red",
            ALTX2: "red",
            ALTX3: "red",
            ALTX4: "red",
            ALTX5: "red",
            ALTPC0: "red",
            SUMPX1: "blue",
            SUMPX2: "blue",
            SUMPX3: "blue",
            SUMPX4: "blue",
            SUMPX5: "blue",
            SUMPC0: "blue",
        };
        row = {
            WARPX1: 0,
            WARPX2: 1,
            WARPX3: 2,
            WARPX4: 3,
            WARPX5: 4,
            WARPC0: 5,
            ALTX1: 0,
            ALTX2: 1,
            ALTX3: 2,
            ALTX4: 3,
            ALTX5: 4,
            ALTPC0: 5,
            SUMPX1: 0,
            SUMPX2: 1,
            SUMPX3: 2,
            SUMPX4: 3,
            SUMPX5: 4,
            SUMPC0: 5,
        };
    } else if (plot_element.data.dataset == "radio_alerts_noaa") {
        colors = {
            ALTTP2: "red",
            ALTTP4: "red",
            SUM10R: "blue",
        };
        row = {
            ALTTP2: 0,
            ALTTP4: 1,
            SUM10R: 2,
        };
    } else if (plot_element.data.dataset == "electronflux_alerts_noaa") {
        colors = {
            ALTEF3: "red",
        };
        row = {
            ALTEF3: 0,
        };
    } else if (plot_element.data.dataset == "geomagnetic_alerts_noaa") {
        colors = {
            WARSUD: "orange",
            SUMSUD: "blue",
            ALTK04: "red",
            ALTK05: "red",
            ALTK06: "red",
            ALTK07: "red",
            ALTK08: "red",
            ALTK09: "red",
            WARK04: "orange",
            WARK05: "orange",
            WARK06: "orange",
            WARK07: "orange",
            WARK08: "orange",
            WARK09: "orange",
            WATA20: "green",
            WATA30: "green",
            WATA50: "green",
            WATA99: "green",
        };
        row = {
            WARSUD: 0,
            SUMSUD: 0,
            ALTK04: 1,
            ALTK05: 2,
            ALTK06: 3,
            ALTK07: 4,
            ALTK08: 5,
            ALTK09: 6,
            WARK04: 1,
            WARK05: 2,
            WARK06: 3,
            WARK07: 4,
            WARK08: 5,
            WARK09: 6,
            WATA20: 7,
            WATA30: 8,
            WATA50: 9,
            WATA99: 10,
        };
    } else {
        console.log("This type is not yet implemented");
    }

    const show_notification = function (e) {
        alert(e.srcElement.attributes["data-message"].value);
    };
</script>

{#each data.datalist as d}
    <g on:click={show_notification}>
        <title>Notification: {d.product_id}</title>
        <circle
            cx={xScale(new Date(d.time))}
            cy={yScale(ymaxrow - row[d.product_id])}
            r="5px"
            fill={colors[d.product_id]}
            data-message="{d.product_id}: {d.original_message}" />
        {#if d.begin_time.length > 0}
            <line
                x1={xScale(new Date(d.begin_time))}
                x2={xScale(new Date(d.time))}
                y1={yScale(ymaxrow - row[d.product_id])}
                y2={yScale(ymaxrow - row[d.product_id])}
                stroke-width="2px"
                stroke={colors[d.product_id]}
                data-message="{d.product_id}: {d.original_message}" />
        {/if}
        {#if d.begin_time.length > 0 && d.end_time.length > 0}
            <line
                x1={xScale(new Date(d.begin_time))}
                x2={xScale(new Date(d.end_time))}
                y1={yScale(ymaxrow - row[d.product_id])}
                y2={yScale(ymaxrow - row[d.product_id])}
                stroke-width="6px"
                stroke={colors[d.product_id]}
                data-message="{d.product_id}: {d.original_message}" />
        {/if}
    </g>
{/each}

<style>
    circle {
        cursor: pointer;
    }
    line {
        cursor: pointer;
    }
</style>